var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class BaseGameGroup extends Phaser.Group {
        constructor(scene) {
            super(scene.game, null);
            this.disposables = [];
            this.scene = scene;
        }
        checkAndLoadImage(key, path, callback, callbackContext) {
            this.scene.checkAndLoadImage(key, path, callback, callbackContext);
        }
        checkAndLoadSpriteSheet(key, path, frameWidth, frameHeight, magin, spacing, callback, callbackContext) {
            this.scene.checkAndLoadSpriteSheet(key, path, frameWidth, frameHeight, magin, spacing, callback, callbackContext);
        }
        checkAndLoadImageAsync(key, path) {
            return __awaiter(this, void 0, void 0, function* () {
                return this.scene.checkAndLoadImageAsync(key, path);
            });
        }
        getCurrentScene() {
            return this.scene;
        }
        addDisposable(dis) {
            this.disposables.push(dis);
        }
        destroy(destroyChildren, soft) {
            for (let d of this.disposables) {
                d.dispose();
            }
            this.disposables = [];
            super.destroy(destroyChildren, soft);
        }
    }
    exports.BaseGameGroup = BaseGameGroup;
});
//# sourceMappingURL=baseGameGroup.js.map