define(["require", "exports", "./baseConfiguration"], function (require, exports, baseConfiguration_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class AchievementConfiguration extends baseConfiguration_1.BaseConfiguration {
        constructor() {
            super(...arguments);
            this.entries = new Map();
        }
        get configName() {
            return "achievement";
        }
        initWithJson(json) {
            let len = Object.keys(json).length;
            this.orderedList = [];
            for (let i = 0; i < len; i++) {
                let b = json[i];
                this.entries.set(b.id, b);
                this.orderedList.push(b);
            }
            this.orderedList.sort(((a, b) => {
                if (a.type == b.type) {
                    return a.times - b.times;
                }
                return a.type - b.type;
            }));
        }
        getOrderedList() {
            return this.orderedList;
        }
        get(id) {
            if (this.entries.has(id)) {
                return this.entries.get(id);
            }
            console.warn(`get achievement [${id}] failed`);
            return null;
        }
        get size() {
            return this.entries.size;
        }
    }
    exports.AchievementConfiguration = AchievementConfiguration;
});
//# sourceMappingURL=achievementConfiguration.js.map