define(["require", "exports", "./baseConfiguration"], function (require, exports, baseConfiguration_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class DifficultyConfiguration extends baseConfiguration_1.BaseConfiguration {
        constructor() {
            super(...arguments);
            this.entries = new Map();
        }
        get configName() {
            return "difficulty";
        }
        initWithJson(json) {
            let len = Object.keys(json).length;
            for (let i = 0; i < len; i++) {
                let b = json[i];
                this.entries.set(b.level, b);
            }
        }
        get(lv) {
            if (this.entries.has(lv)) {
                return this.entries.get(lv);
            }
            console.warn(`get difficulty [${lv}] failed`);
            return null;
        }
        get size() {
            return this.entries.size;
        }
    }
    exports.DifficultyConfiguration = DifficultyConfiguration;
});
//# sourceMappingURL=difficultyConfiguration.js.map