define(["require", "exports", "./baseConfiguration"], function (require, exports, baseConfiguration_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class EmotionConfiguration extends baseConfiguration_1.BaseConfiguration {
        constructor() {
            super(...arguments);
            this.entries = {};
            this._size = 0;
        }
        get configName() {
            return "emotion";
        }
        initWithJson(json) {
            let len = Object.keys(json).length;
            for (let i = 0; i < len; i++) {
                let b = json[i];
                let key = b.alias;
                this.entries[key] = b;
                this._size++;
            }
        }
        getConfig(alias) {
            let lvS = alias;
            if (this.entries.hasOwnProperty(lvS)) {
                return this.entries[lvS];
            }
            console.warn(`get skill [${alias}] failed`);
            return null;
        }
        get size() {
            return this._size;
        }
    }
    exports.EmotionConfiguration = EmotionConfiguration;
});
//# sourceMappingURL=emotionConfiguration.js.map