define(["require", "exports", "./baseConfiguration"], function (require, exports, baseConfiguration_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class GameConfigurationEntry {
    }
    class GameConfiguration extends baseConfiguration_1.BaseConfiguration {
        constructor() {
            super(...arguments);
            this.entries = new Map();
        }
        get configName() {
            return "gameConfig";
        }
        initWithJson(json) {
            let len = Object.keys(json).length;
            for (let i = 0; i < len; i++) {
                let b = json[i];
                this.entries.set(b.key, b.value);
            }
        }
        getNum(key) {
            if (this.entries.has(key)) {
                return Number.parseFloat(this.entries.get(key));
            }
            console.warn(`get game config num [${key}] failed`);
            return null;
        }
        getStr(key) {
            if (this.entries.has(key)) {
                return this.entries.get(key);
            }
            console.warn(`get game config str [${key}] failed`);
            return null;
        }
    }
    exports.GameConfiguration = GameConfiguration;
});
//# sourceMappingURL=gameConfiguration.js.map