define(["require", "exports", "./baseConfiguration"], function (require, exports, baseConfiguration_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class NpcDefaultSkillConfiguration extends baseConfiguration_1.BaseConfiguration {
        constructor() {
            super(...arguments);
            this.entries = new Map();
        }
        get configName() {
            return "npcDefaultSkill";
        }
        initWithJson(json) {
            let len = Object.keys(json).length;
            for (let i = 0; i < len; i++) {
                let b = json[i];
                let key = b.npcId.toString();
                let arr;
                if (this.entries.has(key)) {
                    arr = this.entries.get(key);
                }
                else {
                    arr = [];
                    this.entries.set(key, arr);
                }
                arr.push(b);
            }
        }
        get(npcId) {
            let lvS = npcId.toString();
            if (this.entries.has(lvS)) {
                return this.entries.get(lvS);
            }
            console.warn(`get npc default skill [${npcId}] failed`);
            return null;
        }
        get size() {
            return this.entries.size;
        }
    }
    exports.NpcDefaultSkillConfiguration = NpcDefaultSkillConfiguration;
});
//# sourceMappingURL=npcDefaultSkillConfiguration.js.map