define(["require", "exports", "./baseConfiguration"], function (require, exports, baseConfiguration_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class ProjectileConfiguration extends baseConfiguration_1.BaseConfiguration {
        constructor() {
            super(...arguments);
            this.entries = new Map();
        }
        get configName() {
            return "projectile";
        }
        initWithJson(json) {
            let len = Object.keys(json).length;
            for (let i = 0; i < len; i++) {
                let b = json[i];
                this.entries.set(b.id, b);
            }
        }
        getConfig(id) {
            if (this.entries.has(id)) {
                return this.entries.get(id);
            }
            console.warn(`get projectile [${id}] failed`);
            return null;
        }
        get size() {
            return this.entries.size;
        }
    }
    exports.ProjectileConfiguration = ProjectileConfiguration;
});
//# sourceMappingURL=projectileConfiguration.js.map