define(["require", "exports", "./baseConfiguration"], function (require, exports, baseConfiguration_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class SpritesheetConfiguration extends baseConfiguration_1.BaseConfiguration {
        constructor() {
            super(...arguments);
            this.entries = {};
            this._size = 0;
        }
        get configName() {
            return "spritesheet";
        }
        initWithJson(json) {
            let len = Object.keys(json).length;
            for (let i = 0; i < len; i++) {
                let b = json[i];
                let key = b.id.toString();
                this.entries[key] = b;
                this._size++;
            }
        }
        getConfig(id) {
            let lvS = id.toString();
            if (this.entries.hasOwnProperty(lvS)) {
                return this.entries[lvS];
            }
            console.warn(`get spritesheet [${id}] failed`);
            return null;
        }
        get size() {
            return this._size;
        }
    }
    exports.SpritesheetConfiguration = SpritesheetConfiguration;
});
//# sourceMappingURL=spritesheetConfiguration.js.map