define(["require", "exports", "../utils/eventbus", "../utils/configUtil", "../models/modelStore"], function (require, exports, eventbus_1, configUtil_1, modelStore_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class BaseLogic extends eventbus_1.Eventbus {
        get serviceProvider() {
            return this._serviceProvider;
        }
        set serviceProvider(value) {
            this._serviceProvider = value;
        }
        get platform() {
            return this._serviceProvider.getServiceByName("platformUtil");
        }
        get configUtil() {
            return this._serviceProvider.getService(configUtil_1.ConfigUtil);
        }
        get store() {
            return this._serviceProvider.getService(modelStore_1.ModelStore);
        }
        get name() {
            return this.constructor.name;
        }
        registerEvents() {
        }
        notifyEventS(name, value) {
            this.emit(name, value);
        }
        onEventS(evt, caller, listener, once) {
            if (once) {
                return this.once(evt, (event) => {
                    listener.call(caller, event);
                });
            }
            return this.on(evt, (event) => {
                listener.call(caller, event);
            });
        }
    }
    exports.BaseLogic = BaseLogic;
});
//# sourceMappingURL=baseLogic.js.map