define(["require", "exports", "./baseModel"], function (require, exports, baseModel_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var AchievementEvent;
    (function (AchievementEvent) {
        AchievementEvent[AchievementEvent["MonsterKilled"] = 1] = "MonsterKilled";
        AchievementEvent[AchievementEvent["BossKilled"] = 2] = "BossKilled";
        AchievementEvent[AchievementEvent["UpgradeNpcLevel"] = 3] = "UpgradeNpcLevel";
        AchievementEvent[AchievementEvent["BuyNpc"] = 4] = "BuyNpc";
        AchievementEvent[AchievementEvent["UnlockDifficulty"] = 5] = "UnlockDifficulty";
        AchievementEvent[AchievementEvent["SocialShare"] = 6] = "SocialShare";
        AchievementEvent[AchievementEvent["RemoveAd"] = 7] = "RemoveAd";
        AchievementEvent[AchievementEvent["DamageToMonster"] = 8] = "DamageToMonster";
    })(AchievementEvent = exports.AchievementEvent || (exports.AchievementEvent = {}));
    class AchievementModel extends baseModel_1.BaseModel {
        constructor(source) {
            super();
            for (let n in source) {
                this['_' + n] = source[n];
            }
        }
        get configId() {
            return this._configId;
        }
        set configId(value) {
            this._configId = value;
        }
        get progress() {
            return this._progress;
        }
        set progress(value) {
            this._progress = value;
        }
        get type() {
            return this._type;
        }
        set type(value) {
            this._type = value;
        }
        get event() {
            return this._event;
        }
        set event(value) {
            this._event = value;
        }
        toObject() {
            let obj1 = super.toObject();
            let obj2 = {
                type: this._type,
                progress: this._progress,
                configId: this._configId
            };
            return Object.assign({}, obj1, obj2);
        }
        genKey() {
            return AchievementModel._name + "_" + this._type;
        }
    }
    AchievementModel._name = "achievement";
    exports.AchievementModel = AchievementModel;
});
//# sourceMappingURL=achievementModel.js.map