define(["require", "exports", "../utils/eventbus"], function (require, exports, eventbus_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class BaseModel extends eventbus_1.Eventbus {
        constructor() {
            super(...arguments);
            this._dirty = false;
        }
        get dirty() {
            return this._dirty;
        }
        set dirty(value) {
            this._dirty = value;
        }
        notifyPropertyChangeS(name, value) {
            this._dirty = true;
            this.emit(name, value);
        }
        onPropertyChanged(caller, listener) {
            let ref = this.on("*", (event) => {
                if (!caller.parent) {
                    ref.dispose();
                    return;
                }
                listener.apply(caller, event);
            });
        }
        onPropertyChangedS(evt, caller, listener) {
            return this.on(evt, (event) => {
                listener.call(caller, event);
            });
        }
        toObject() {
            return {};
        }
    }
    exports.BaseModel = BaseModel;
});
//# sourceMappingURL=baseModel.js.map