define(["require", "exports", "./baseModel", "../utils/mathUtil"], function (require, exports, baseModel_1, mathUtil_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class MonsterEmitterModel extends baseModel_1.BaseModel {
        constructor(source) {
            super();
            if (source == null) {
                this._percentage = 0;
            }
            else {
                for (let n in source) {
                    this['_' + n] = source[n];
                }
            }
        }
        get configId() {
            return this._configId;
        }
        set configId(value) {
            if (value != this._configId) {
                this._configId = value;
                this.notifyPropertyChangeS("configId", value);
            }
        }
        get percentage() {
            return this._percentage;
        }
        set percentage(value) {
            if (value != this._percentage) {
                this._percentage = value;
                this.notifyPropertyChangeS("percentage", value);
            }
        }
        get level() {
            return this._level;
        }
        set level(value) {
            if (value != this._level) {
                this._level = value;
                this.notifyPropertyChangeS("level", value);
            }
        }
        toObject() {
            let obj1 = super.toObject();
            let obj2 = {
                level: this._level,
                configId: this._configId
            };
            return Object.assign({}, obj1, obj2);
        }
        notifyPropertyChangeS(event, eventData) {
            super.notifyPropertyChangeS(event, eventData);
        }
        onPropertyChangedS(event, caller, listener) {
            return super.onPropertyChangedS(event, caller, listener);
        }
        getRand() {
            return mathUtil_1.MathUtil.getRandomInt(2147483647);
        }
        genKey() {
            return MonsterEmitterModel._name;
        }
    }
    MonsterEmitterModel._name = "monster_emitter";
    exports.MonsterEmitterModel = MonsterEmitterModel;
});
//# sourceMappingURL=monsterEmitterModel.js.map