define(["require", "exports", "./baseModel"], function (require, exports, baseModel_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class PlayerModel extends baseModel_1.BaseModel {
        constructor(source) {
            super();
            this._gold = 0;
            this._magicEssence = 0;
            this._gauge = 0;
            this._lastGetReward = 0;
            this._passGuide = true;
            this._hasLinkAccount = false;
            if (typeof source === 'string') {
                this._id = source;
            }
            else {
                for (let n in source) {
                    this['_' + n] = source[n];
                }
            }
        }
        get hasLinkAccount() {
            return this._hasLinkAccount;
        }
        set hasLinkAccount(value) {
            this._hasLinkAccount = value;
        }
        get passGuide() {
            return this._passGuide;
        }
        set passGuide(value) {
            this._passGuide = value;
        }
        get lastGetReward() {
            return this._lastGetReward;
        }
        set lastGetReward(value) {
            this._lastGetReward = value;
        }
        get id() {
            return this._id;
        }
        get magicEssence() {
            return this._magicEssence;
        }
        set magicEssence(value) {
            if (value != this._magicEssence) {
                this._magicEssence = value;
                this.notifyPropertyChangeS("magicEssence", value);
            }
        }
        get gold() {
            return this._gold;
        }
        set gold(value) {
            if (value != this._gold) {
                this._gold = value;
                this.notifyPropertyChangeS("gold", value);
            }
        }
        get gauge() {
            return this._gauge;
        }
        get gaugeInSeconds() {
            return Math.floor(this.gauge / 1000);
        }
        set gauge(value) {
            if (value != this._gauge) {
                this._gauge = value;
                if (this._gauge < 0) {
                    this._gauge = 0;
                }
                this.notifyPropertyChangeS("gauge", value);
            }
        }
        toObject() {
            let obj1 = super.toObject();
            let obj2 = {
                gold: this._gold,
                id: this._id,
                magicEssence: this._magicEssence,
                gauge: this._gauge,
                lastGetReward: this._lastGetReward,
                passGuide: this._passGuide,
                hasLinkAccount: this._hasLinkAccount
            };
            return Object.assign({}, obj1, obj2);
        }
        notifyPropertyChangeS(event, eventData) {
            super.notifyPropertyChangeS(event, eventData);
        }
        onPropertyChangedS(event, caller, listener) {
            return super.onPropertyChangedS(event, caller, listener);
        }
        static genKey(id) {
            return PlayerModel._name + "_" + id;
        }
        genKey() {
            return PlayerModel.genKey(this._id);
        }
    }
    PlayerModel._name = "player";
    exports.PlayerModel = PlayerModel;
});
//# sourceMappingURL=playerModel.js.map