define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class BaseBuff {
        constructor(removeEvent, buffType, maxOverlap, positive) {
            this._overlap = 1;
            this._isTimeout = false;
            this._effects = new Map();
            this._removeEvent = removeEvent;
            this._buffType = buffType;
            this._maxOverlap = maxOverlap;
            this._positive = positive;
        }
        get positive() {
            return this._positive;
        }
        get maxOverlap() {
            return this._maxOverlap;
        }
        get duration() {
            return this._duration;
        }
        get start() {
            return this._start;
        }
        get effects() {
            return this._effects.values();
        }
        get buffType() {
            return this._buffType;
        }
        get overlap() {
            return this._overlap;
        }
        get times() {
            return this._times;
        }
        get removeEvent() {
            return this._removeEvent;
        }
        set times(value) {
            this._times = value;
        }
        set start(value) {
            this._start = value;
        }
        set duration(value) {
            this._duration = value;
        }
        set overlap(value) {
            this._overlap = value;
        }
        set isTimeout(value) {
            this._isTimeout = value;
        }
        get isFinished() {
            return this._times <= 0 || this._isTimeout;
        }
        compareTo(other) {
            if (this._buffType != other._buffType) {
                return 2;
            }
            return 0;
        }
        addEffect(status, percent, value) {
            this._effects.set(status, { status: status, percent: percent, value: value });
        }
        getEffect(status) {
            return this._effects.get(status);
        }
    }
    BaseBuff.CustomBuffStartType = 1000000;
    BaseBuff.AttackStatus = 1;
    BaseBuff.MoveSpeedStatus = 2;
    BaseBuff.DefenseStatus = 3;
    exports.BaseBuff = BaseBuff;
});
//# sourceMappingURL=baseBuff.js.map