define(["require", "exports", "./baseSkill", "../buff/baseBuff"], function (require, exports, baseSkill_1, baseBuff_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class AllBuffSpell extends baseSkill_1.BaseSkill {
        doUpdateFrame() {
            const npcs = this.field.npcs;
            for (let buffId of this.config.buffs) {
                const buffConfig = this.buffConfigUtil.getConfig(buffId);
                for (let npc of npcs) {
                    if (npc == this.npc) {
                        continue;
                    }
                    const buffs = npc.buffs;
                    let count = 0;
                    for (let buff of buffs) {
                        if (buff.buffType == buffConfig.type) {
                            count = buff.overlap;
                        }
                    }
                    if (count < buffConfig.overlap) {
                        let buff = this.createBuff(buffId);
                        buff.getEffect(baseBuff_1.BaseBuff.AttackStatus).percent += this.npc.model.level / 100;
                        this.applyDamage(npc, null, buff);
                    }
                }
            }
            this.showTargetEffect(null);
            this.showActorEffect(null);
            this.finished = true;
        }
        showTargetEffect(target) {
            const rect = this.field.boundingBox;
            let effect = this.game.make.sprite(rect.width / 2, rect.height / 2, this.effectKey);
            effect.anchor.set(0.5, 0.5);
            effect.animations.add("attack", this.config.animation);
            effect.animations.play("attack", 15, false, true);
            this.field.addChild(effect);
        }
        showActorEffect(target, speed = 1, times = 1) {
            const rect = this.field.boundingBox;
            this.npc.fight(speed, times);
            this.npc.position.set(rect.width / 2, rect.height / 2);
        }
    }
    exports.AllBuffSpell = AllBuffSpell;
});
//# sourceMappingURL=allBuffSpell.js.map