define(["require", "exports", "./baseSkill", "../../../utils/mathUtil", "../buff/baseBuff"], function (require, exports, baseSkill_1, mathUtil_1, baseBuff_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class BuffSpell extends baseSkill_1.BaseSkill {
        doUpdateFrame() {
            const npcs = this.field.npcs;
            let targets = [];
            for (let buffId of this.config.buffs) {
                const buffConfig = this.buffConfigUtil.getConfig(buffId);
                for (let npc of npcs) {
                    if (npc == this.npc) {
                        continue;
                    }
                    const buffs = npc.buffs;
                    let count = 0;
                    for (let buff of buffs) {
                        if (buff.buffType == buffConfig.type) {
                            count = buff.overlap;
                        }
                    }
                    if (count < buffConfig.overlap) {
                        targets.push(npc);
                    }
                }
                if (targets.length > 0) {
                    const target = targets[mathUtil_1.MathUtil.getRandomInt(targets.length)];
                    this.showTargetEffect(target);
                    this.showActorEffect(target);
                    let buff = this.createBuff(buffId);
                    buff.getEffect(baseBuff_1.BaseBuff.AttackStatus).percent += this.npc.model.level / 100;
                    this.applyDamage(target, null, buff);
                    break;
                }
            }
            this.finished = true;
        }
        showActorEffect(target, speed = 1, times = 1) {
            this.npc.fight(speed, times);
            this.npc.position.set(target.x, target.y + target.height);
        }
    }
    exports.BuffSpell = BuffSpell;
});
//# sourceMappingURL=buffSpell.js.map