define(["require", "exports", "./baseSkill"], function (require, exports, baseSkill_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class FlashExplosion extends baseSkill_1.BaseSkill {
        doUpdateFrame() {
            const maxDamage = this.calculateAttack() * 5;
            let targets = this.findTargets();
            if (targets.length > 0) {
                const target = targets[Math.floor(targets.length / 2)];
                const maxHorizonDistance = 32;
                for (let m of targets) {
                    if (m.xUnit > target.xUnit + maxHorizonDistance || m.xUnit < target.xUnit - target.widthUnit - maxHorizonDistance) {
                        continue;
                    }
                    if (m.yUnit > target.yUnit + 32 || m.yUnit < target.yUnit - 32) {
                        continue;
                    }
                    let distance = Math.min(maxHorizonDistance, Math.abs(m.xUnit - target.xUnit));
                    this.applyDamage(m, [this.getFinalDamage(maxDamage * (1 - distance / maxHorizonDistance / 2), m)]);
                }
                this.showActorEffect(target);
                this.showTargetEffect(target);
            }
            this.finished = true;
        }
        showTargetEffect(target) {
            let effect = this.game.make.sprite(this.npc.x - this.npc.width, this.npc.y, this.effectKey);
            effect.anchor.set(0.5, 0.5);
            effect.animations.add("attack", this.config.animation);
            effect.animations.play("attack", 9, false, true);
            this.field.addChild(effect);
            this.field.sendToBack(effect);
        }
    }
    exports.FlashExplosion = FlashExplosion;
});
//# sourceMappingURL=flashExplosion.js.map