define(["require", "exports", "./baseSkill"], function (require, exports, baseSkill_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class IceImpact extends baseSkill_1.BaseSkill {
        doUpdateFrame() {
            let targets = this.findTargets();
            if (targets.length > 0) {
                const target = targets[0];
                for (let m of targets) {
                    if (m.xUnit > target.xUnit) {
                        continue;
                    }
                    if (m.yUnit > target.yUnit + 48 || m.yUnit < target.yUnit - 16) {
                        continue;
                    }
                    this.applyDamage(m, [this.calculateDamage(m)]);
                }
                this.showActorEffect(target);
                this.showTargetEffect(target);
            }
            this.finished = true;
        }
        showTargetEffect(target) {
            let effect = this.game.make.sprite(target.x, target.y, this.effectKey);
            effect.anchor.set(1, 0.5);
            effect.animations.add("attack", this.config.animation);
            effect.animations.play("attack", 9, false, true);
            this.field.addChild(effect);
        }
    }
    exports.IceImpact = IceImpact;
});
//# sourceMappingURL=iceImpact.js.map