define(["require", "exports", "./baseSkill"], function (require, exports, baseSkill_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class Judgement extends baseSkill_1.BaseSkill {
        doUpdateFrame() {
            if (this.anime == null) {
                this.showActorEffect(null, 0.5);
                this.showTargetEffect(this.npc);
            }
            else if (this.anime.frame == this.anime.frameTotal / 2) {
                let targets = this.field.monsters;
                const attack = this.calculateAttack();
                for (let m of targets) {
                    let critical = m.defenseType == 6;
                    let damage = this.getFinalDamage(attack, m, critical, true);
                    if (critical) {
                        damage.value *= 2;
                    }
                    this.applyDamage(m, [damage]);
                }
                this.finished = true;
            }
        }
        showTargetEffect(target) {
            let effect = this.game.make.sprite(target.x, 5, this.effectKey);
            effect.anchor.set(0.5, 0);
            effect.scale.set(2);
            effect.animations.add("attack", this.config.animation);
            this.anime = effect.animations.play("attack", 8, false, true);
            this.field.addChild(effect);
        }
        showActorEffect(target, speed = 1, times = 1) {
            this.npc.fight(speed, times);
            this.npc.position.set(this.field.boundingBox.width / 2, this.field.boundingBox.y + this.field.boundingBox.height / 2);
        }
    }
    exports.Judgement = Judgement;
});
//# sourceMappingURL=judgement.js.map