define(["require", "exports", "./baseSkill"], function (require, exports, baseSkill_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class Magma extends baseSkill_1.BaseSkill {
        doUpdateFrame() {
            const totalDamage = this.calculateAttack() * 10;
            let targets = this.findTargets();
            let newTargets = new Array();
            if (targets.length > 0) {
                const target = targets[Math.floor(targets.length / 2)];
                for (let m of targets) {
                    if (m.xUnit > target.xUnit + 32 || m.xUnit < target.xUnit - target.widthUnit - 32) {
                        continue;
                    }
                    if (m.yUnit > target.yUnit + 32 || m.yUnit < target.yUnit - 32) {
                        continue;
                    }
                    newTargets.push(m);
                }
                const damage = totalDamage / newTargets.length;
                for (let m of newTargets) {
                    this.applyDamage(m, [this.getFinalDamage(damage, m)]);
                }
                this.showActorEffect(target);
                this.showTargetEffect(target);
            }
            this.finished = true;
        }
        showTargetEffect(target) {
            let effect = this.game.make.sprite(this.npc.x - this.npc.width / 2, this.npc.y, this.effectKey);
            effect.anchor.set(0.5, 0.5);
            effect.animations.add("attack", this.config.animation);
            effect.animations.play("attack", 15, false, true);
            this.field.addChild(effect);
            this.field.sendToBack(effect);
        }
    }
    exports.Magma = Magma;
});
//# sourceMappingURL=magma.js.map