define(["require", "exports", "./baseSkill", "../../../ui/characters/monsterCharacter", "../../../utils/mathUtil"], function (require, exports, baseSkill_1, monsterCharacter_1, mathUtil_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class RemoteAttack extends baseSkill_1.BaseSkill {
        doUpdateFrame() {
            let targets = this.findTargets();
            if (targets.length > 0) {
                let max = Math.ceil(this.npc.model.level / 20) + 2;
                let target = null;
                for (let i = targets.length - 1; i >= 0; i--) {
                    if (max < 1) {
                        break;
                    }
                    target = targets[i];
                    this.showProjectileEffect(target, this.calculateDamage(target));
                    max--;
                }
                if (target != null) {
                    this.showActorEffect(target);
                }
            }
            this.finished = true;
        }
        showActorEffect(target, speed = 1, times = 1) {
            this.npc.fight(speed, times);
            this.npc.position.set(this.npc.x, target.y);
        }
    }
    exports.RemoteAttack = RemoteAttack;
    class DeathArrow extends RemoteAttack {
        doUpdateFrame() {
            if (this.action == null) {
                let targets = this.findTargets();
                if (targets.length > 0) {
                    let target = targets[mathUtil_1.MathUtil.getRandomInt(targets.length)];
                    this.action = this.showProjectileEffect(target);
                    this.showActorEffect(target);
                }
                if (this.action == null) {
                    this.finished = true;
                }
            }
            else if (this.action.finished) {
                const target = this.action.target;
                if ((target instanceof monsterCharacter_1.MonsterCharacter) && target.alive) {
                    let dmg;
                    if (target.model.isBoss || target.defenseType == 6) {
                        dmg = this.calculateDamage(target);
                    }
                    else {
                        dmg = this.getFinalDamage(0, target);
                        dmg.value = target.model.maxHp;
                    }
                    target.suffer([dmg]);
                    this.showTargetEffect(target);
                }
                this.finished = true;
            }
        }
    }
    exports.DeathArrow = DeathArrow;
});
//# sourceMappingURL=remoteAttack.js.map