define(["require", "exports", "./sonicPunch", "./normalAttack", "./buffSpell", "./swordSlash", "./magma", "./flashExplosion", "./allBuffSpell", "./remoteAttack", "./astralArrow", "./passive/masterSword", "./judgement", "./iceImpact"], function (require, exports, sonicPunch_1, normalAttack_1, buffSpell_1, swordSlash_1, magma_1, flashExplosion_1, allBuffSpell_1, remoteAttack_1, astralArrow_1, masterSword_1, judgement_1, iceImpact_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class SkillFactory {
        create(type, field, model, actor) {
            let ret = null;
            switch (type) {
                case 1:
                    ret = new sonicPunch_1.SonicPunch(field, model, actor);
                    break;
                case 2:
                    ret = new normalAttack_1.NormalAttack(field, model, actor);
                    break;
                case 3:
                    ret = new buffSpell_1.BuffSpell(field, model, actor);
                    break;
                case 4:
                    ret = new swordSlash_1.SwordSlash(field, model, actor);
                    break;
                case 5:
                    ret = new magma_1.Magma(field, model, actor);
                    break;
                case 6:
                    ret = new flashExplosion_1.FlashExplosion(field, model, actor);
                    break;
                case 7:
                    ret = new allBuffSpell_1.AllBuffSpell(field, model, actor);
                    break;
                case 8:
                    ret = new remoteAttack_1.RemoteAttack(field, model, actor);
                    break;
                case 9:
                    ret = new astralArrow_1.AstralArrow(field, model, actor);
                    break;
                case 10:
                    ret = new masterSword_1.MasterSword(field, model, actor);
                    break;
                case 11:
                    ret = new judgement_1.Judgement(field, model, actor);
                    break;
                case 12:
                    ret = new remoteAttack_1.DeathArrow(field, model, actor);
                    break;
                case 13:
                    ret = new iceImpact_1.IceImpact(field, model, actor);
                    break;
            }
            return ret;
        }
    }
    exports.SkillFactory = SkillFactory;
});
//# sourceMappingURL=skillFactory.js.map