define(["require", "exports", "./baseSkill"], function (require, exports, baseSkill_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class SonicPunch extends baseSkill_1.BaseSkill {
        constructor() {
            super(...arguments);
            this._damageTimes = 5;
        }
        doUpdateFrame() {
            let targets = this.findTargets();
            if (targets.length > 0) {
                let target = targets[0];
                let dmgs = [];
                const times = this._damageTimes;
                for (let i = 0; i < times; i++) {
                    let dmg = this.calculateDamage(target);
                    dmgs.push(dmg);
                }
                this.applyDamage(target, dmgs);
                this.showTargetEffect(target);
                this.showActorEffect(target);
            }
            this.finished = true;
        }
    }
    exports.SonicPunch = SonicPunch;
});
//# sourceMappingURL=sonicPunch.js.map