define(["require", "exports", "./baseSkill"], function (require, exports, baseSkill_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class SwordSlash extends baseSkill_1.BaseSkill {
        doUpdateFrame() {
            let targets = this.findTargets();
            if (targets.length > 0) {
                const target = targets[0];
                for (let m of targets) {
                    if (m.xUnit > target.xUnit + 1 || m.xUnit < target.xUnit - target.widthUnit - 1) {
                        continue;
                    }
                    if (m.yUnit > target.yUnit + 64 || m.yUnit < target.yUnit - 64) {
                        continue;
                    }
                    this.applyDamage(m, [this.calculateDamage(m)]);
                }
                this.showActorEffect(target);
                this.showTargetEffect(target);
            }
            this.finished = true;
        }
        showTargetEffect(target) {
            let effect = this.game.make.sprite(this.npc.x - this.npc.width, this.npc.y, this.effectKey);
            effect.anchor.set(0.5, 0.5);
            effect.animations.add("attack", this.config.animation);
            effect.animations.play("attack", 15, false, true);
            this.field.addChild(effect);
        }
    }
    exports.SwordSlash = SwordSlash;
});
//# sourceMappingURL=swordSlash.js.map