var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "./baseScene", "./gameScene", "../logics/playerLogic"], function (require, exports, baseScene_1, gameScene_1, playerLogic_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class EntryScene extends baseScene_1.BaseScene {
        constructor(sp) {
            super("game_entry", sp);
        }
        createAsync() {
            return __awaiter(this, void 0, void 0, function* () {
                const pl = this.getLogic(playerLogic_1.PlayerLogic);
                yield pl.initPlayerAsync();
                yield pl.initNpcAsync();
                yield pl.initBattlefieldAsync();
                yield pl.initAchievementAsync();
                yield pl.initMonsterEmitterAsync();
                new baseScene_1.SceneTransition(this.game, new gameScene_1.GameScene(this.serviceProvider)).start();
                const pf = this.platform;
                yield pf.loginAsync();
                yield pf.showAdAsync();
            });
        }
    }
    exports.EntryScene = EntryScene;
});
//# sourceMappingURL=entryScene.js.map