define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class ServiceProvider {
        constructor() {
            this._singletons = new Map();
        }
        getService(c) {
            return this.getServiceByName(c.name);
        }
        getServiceByName(name) {
            let r = this._singletons.get(name);
            if (r != null) {
                return r;
            }
            return null;
        }
        addSingleton(c) {
            this.addSingletonByName(c.constructor.name, c);
        }
        addSingletonByName(name, c) {
            this._singletons.set(name, c);
        }
    }
    exports.ServiceProvider = ServiceProvider;
});
//# sourceMappingURL=serviceProvider.js.map