var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "../../configs/spritesheetConfiguration"], function (require, exports, spritesheetConfiguration_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class CharacterUI {
        constructor(scene) {
            this._scene = scene;
        }
        preloadResAsync() {
            return __awaiter(this, void 0, void 0, function* () {
                const spritesheetConfiguration = this._scene.configUtil.getConfig(spritesheetConfiguration_1.SpritesheetConfiguration);
                const spritesheet = spritesheetConfiguration.getConfig(CharacterUI.CommonIconSet);
                this.checkAndLoadSpriteSheet(spritesheet);
            });
        }
        checkAndLoadSpriteSheet(spritesheet, callback, callbackContext) {
            this._scene.checkAndLoadSpriteSheet(CharacterUI.ResPrefix + spritesheet.id, spritesheet.path, spritesheet.dimension[0], spritesheet.dimension[1], spritesheet.dimension[2], spritesheet.dimension[3], callback, callbackContext);
        }
        getAtkTypeIcon(atkType) {
            let row = -1, column = -1;
            switch (atkType) {
                case 1:
                    row = 6;
                    column = 2;
                    break;
                case 2:
                    row = 6;
                    column = 10;
                    break;
                case 3:
                    row = 7;
                    column = 3;
                    break;
                case 4:
                    row = 7;
                    column = 10;
                    break;
                case 5:
                    row = 6;
                    column = 11;
                    break;
                default:
                    return null;
            }
            return this._scene.game.make.sprite(0, 0, CharacterUI.ResPrefix + CharacterUI.CommonIconSet, row * 16 + column);
        }
        getDefTypeIcon(atkType) {
            let row = -1, column = -1;
            switch (atkType) {
                case 1:
                    row = 9;
                    column = 1;
                    break;
                case 2:
                    row = 9;
                    column = 2;
                    break;
                case 3:
                    row = 9;
                    column = 3;
                    break;
                case 4:
                    row = 9;
                    column = 4;
                    break;
                case 5:
                    row = 9;
                    column = 6;
                    break;
                case 6:
                    row = 0;
                    column = 6;
                    break;
                default:
                    return null;
            }
            return this._scene.game.make.sprite(0, 0, CharacterUI.ResPrefix + CharacterUI.CommonIconSet, row * 16 + column);
        }
        getGoldIcon() {
            return this._scene.game.make.sprite(0, 0, CharacterUI.ResPrefix + CharacterUI.CommonIconSet, 18 * 16 + 11);
        }
        getTimerIcon() {
            return this._scene.game.make.sprite(0, 0, CharacterUI.ResPrefix + CharacterUI.CommonIconSet, 2 * 16 + 4);
        }
        getQuestionIcon() {
            return this._scene.game.make.sprite(0, 0, CharacterUI.ResPrefix + CharacterUI.CommonIconSet, 1 * 16 + 7);
        }
        getHandIcon() {
            return this._scene.game.make.sprite(0, 0, CharacterUI.ResPrefix + CharacterUI.CommonIconSet, 1 * 16);
        }
    }
    CharacterUI.CommonIconSet = 16;
    CharacterUI.ResPrefix = "charUI_";
    exports.CharacterUI = CharacterUI;
});
//# sourceMappingURL=characterUI.js.map