define(["require", "exports", "../baseGameGroup"], function (require, exports, baseGameGroup_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class ProgressBar extends baseGameGroup_1.BaseGameGroup {
        get rect() {
            return this._rect;
        }
        setPercent(percent) {
            this._rect.width = this._fg.width * percent;
        }
        constructor(scene, fg, bg) {
            super(scene);
            this.add(bg);
            this.add(fg);
            this._fg = fg;
            this._rect = new Phaser.Rectangle(0, 0, fg.width, fg.height);
            fg.crop(this.rect, false);
        }
        update() {
            if (this._fg) {
                this._fg.updateCrop();
            }
        }
    }
    exports.ProgressBar = ProgressBar;
});
//# sourceMappingURL=progressBar.js.map