var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "../listview/listView", "./husbandMenu", "../../configs/achievementConfiguration"], function (require, exports, listView_1, husbandMenu_1, achievementConfiguration_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class CreditMenu extends husbandMenu_1.HusbandMenu {
        initListViewAsync() {
            return __awaiter(this, void 0, void 0, function* () {
                const scene = this.getCurrentScene();
                const player = scene.modelStore.loadMe();
                const achievements = scene.modelStore.loadByType(player.id, "achievement");
                const achievementConfiguration = scene.configUtil.getConfig(achievementConfiguration_1.AchievementConfiguration);
                let configs = achievementConfiguration.getOrderedList();
                let listView = null;
                const grp = this.game.make.group();
                const arr = new Array();
                let notCompletedIndex = 0;
                let typesToSkip = new Set();
                for (let entry of configs) {
                    if (typesToSkip.has(entry.type)) {
                        continue;
                    }
                    let model = null;
                    for (let temp of achievements) {
                        if (temp.type == entry.type) {
                            model = temp;
                            break;
                        }
                    }
                    let item = new AchievementMenuItem(scene, entry, model);
                    yield item.preloadResAsync();
                    if (item.isCompleted()) {
                        arr.push(item);
                    }
                    else {
                        typesToSkip.add(entry.type);
                        arr.splice(notCompletedIndex, 0, item);
                        notCompletedIndex++;
                    }
                    if (listView == null) {
                        yield item.initViewAsync();
                        const bounds = new Phaser.Rectangle(0, 0, item.width, this.bg.height - this._grayLayerHeight - 40);
                        const options = {
                            direction: 'y',
                            overflow: 100,
                            padding: 10
                        };
                        grp.position.set((this.bg.width - item.width) / 2, this.grayLayer.y + this.grayLayer.height);
                        listView = new listView_1.ListView(this.game, grp, bounds, options);
                    }
                    else {
                        item.initViewAsync().then();
                    }
                }
                for (let entry of arr) {
                    listView.add(entry);
                }
                this.add(grp);
            });
        }
    }
    exports.CreditMenu = CreditMenu;
});
//# sourceMappingURL=creditMenu.js.map