var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "./platformUtil", "../models/modelStore"], function (require, exports, platformUtil_1, modelStore_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class BrowserUtil extends platformUtil_1.PlatformUtil {
        constructor() {
            super(...arguments);
            this.loggedInGoogle = false;
        }
        get isMobile() {
            return false;
        }
        getUUIDAsync() {
            return __awaiter(this, void 0, void 0, function* () {
                const store = this.serviceProvider.getService(modelStore_1.ModelStore);
                const key = BrowserUtil.BrowserInfoKey;
                let info = yield store.loadDbAsync(key);
                if (info == null) {
                    info = { uuid: "tm" + Date.now().toString() };
                    yield store.saveRawDbAsync(key, info);
                }
                return info.uuid;
            });
        }
        loginAsync() {
            return __awaiter(this, void 0, void 0, function* () {
                const uuid = yield this.getUUIDAsync();
                return new Promise((resolve) => {
                    let request = {
                        CustomId: uuid,
                        CreateAccount: true,
                        TitleId: this.playFabTitleId
                    };
                    PlayFabClientSDK.LoginWithCustomID(request, this.loginPFCallback(resolve));
                });
            });
        }
        share(message, url, onSuccess, onFail) {
            onSuccess.call(this);
        }
        getGooglePlayerIdAsync() {
            return __awaiter(this, void 0, void 0, function* () {
                const store = this.serviceProvider.getService(modelStore_1.ModelStore);
                const key = BrowserUtil.BrowserInfoKey;
                let info = yield store.loadDbAsync(key);
                if (info != null) {
                    return info.uuid;
                }
                return null;
            });
        }
        hasLoggedInGoogleAsync() {
            return __awaiter(this, void 0, void 0, function* () {
                return this.loggedInGoogle;
            });
        }
        loginGoogleAsync() {
            return __awaiter(this, void 0, void 0, function* () {
                this.loggedInGoogle = true;
                return true;
            });
        }
        logoutGoogleAsync() {
            return __awaiter(this, void 0, void 0, function* () {
                this.loggedInGoogle = false;
                return true;
            });
        }
    }
    BrowserUtil.BrowserInfoKey = "browser_info";
    exports.BrowserUtil = BrowserUtil;
});
//# sourceMappingURL=browserUtil.js.map