define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class Eventbus {
        constructor() {
            this.listeners = {};
            this.listenersOncer = {};
            this.on = (evt, listener) => {
                let a = this.listeners[evt];
                if (a == null) {
                    a = [];
                    this.listeners[evt] = a;
                }
                a.push(listener);
                return {
                    dispose: () => this.off(evt, listener)
                };
            };
            this.once = (evt, listener) => {
                let a = this.listenersOncer[evt];
                if (a == null) {
                    a = [];
                    this.listenersOncer[evt] = a;
                }
                a.push(listener);
                return {
                    dispose: () => this.off(evt, listener)
                };
            };
            this.off = (evt, listener) => {
                for (let i = 0; i < 2; i++) {
                    let a = i == 0 ? this.listenersOncer[evt] : this.listeners[evt];
                    if (a == null)
                        continue;
                    let callbackIndex = a.indexOf(listener);
                    if (callbackIndex > -1)
                        a.splice(callbackIndex, 1);
                }
            };
            this.emit = (evt, data) => {
                let a = this.listeners[evt];
                if (a != null) {
                    let b = a.slice(0);
                    b.forEach((listener) => listener(data));
                }
                a = this.listenersOncer[evt];
                if (a != null) {
                    a.forEach((listener) => listener(data));
                    this.listenersOncer[evt] = [];
                }
            };
        }
    }
    exports.Eventbus = Eventbus;
});
//# sourceMappingURL=eventbus.js.map