define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class FontUtil {
        static getTitleFont() {
            return { font: '30px Courier', fill: '#ffda95', fontWeight: FontUtil.DFW };
        }
        static getAttributeFont() {
            return { font: '24px Courier', fill: '#000000', fontWeight: 'bold' };
        }
        static getWarningAttributeFont() {
            return { font: '24px Courier', fill: '#e60000', fontWeight: FontUtil.DFW };
        }
        static getNumberFont(size, fill = '#ffffff', fontWeight = "bold", strokeThickness = 3) {
            return { font: size + 'px GenShinGothic', fill: fill, fontWeight: fontWeight, strokeThickness: strokeThickness };
        }
        static getTextFont(size, fill = '#ffffff', fontWeight = FontUtil.DFW, strokeThickness = 3) {
            return { font: size + 'px PixelMplus12-Regular', fill: fill, fontWeight: fontWeight, strokeThickness: strokeThickness };
        }
        static getTabTitleFont(activated) {
            if (activated) {
                return { font: '30px Courier', fill: '#c09e5c', fontWeight: FontUtil.DFW };
            }
            else {
                return { font: '30px Courier', fill: '#7b4b37', fontWeight: FontUtil.DFW };
            }
        }
    }
    FontUtil.DFW = "normal";
    exports.FontUtil = FontUtil;
});
//# sourceMappingURL=fontUtil.js.map