var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "./engineUtil"], function (require, exports, engineUtil_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class I18n {
        static initAsync(game, locale) {
            return __awaiter(this, void 0, void 0, function* () {
                const idx = locale.indexOf("-");
                let name = locale;
                if (idx > 0) {
                    name = locale.substring(0, idx);
                }
                game.load.json(name, "configs/trillions_monsters_" + name + ".json");
                yield engineUtil_1.EngineUtil.loadStartAsync(game);
                if (!game.cache.checkJSONKey(name)) {
                    game.load.json(name, "configs/trillions_monsters_en.json");
                    yield engineUtil_1.EngineUtil.loadStartAsync(game);
                }
                let temp = game.cache.getJSON(name);
                const trans = new Map();
                for (let key of Object.keys(temp)) {
                    trans.set(key, temp[key]);
                }
                I18n.trans = trans;
            });
        }
        static t(key) {
            let ret = I18n.trans.get(key);
            if (ret == null) {
                return key;
            }
            return ret;
        }
        static tn(key, ...args) {
            let ret = this.t(key);
            for (let i = 0, m = args.length; i < m; i++) {
                let arg = args[i];
                ret = ret.replace("{" + i + "}", arg);
            }
            return ret;
        }
    }
    exports.I18n = I18n;
});
//# sourceMappingURL=i18n.js.map