define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class IntervalTimer {
        constructor(interval) {
            this._lastCheck = 0;
            this._interval = interval;
        }
        get interval() {
            return this._interval;
        }
        set interval(value) {
            this._interval = value;
        }
        reset() {
            this._lastCheck = Date.now();
        }
        checkAndReset() {
            const now = Date.now();
            if (now - this._lastCheck >= this._interval) {
                this._lastCheck = now;
                return true;
            }
            return false;
        }
    }
    exports.IntervalTimer = IntervalTimer;
});
//# sourceMappingURL=intervalTimer.js.map